import moviepy.editor as mp
from moviepy.video.io.ffmpeg_tools import ffmpeg_extract_subclip
from moviepy.editor import VideoFileClip
import os
from topics_find import text_gen


def convert_video_to_audio(filename):
    clip = mp.VideoFileClip(r"" + filename)
    audio_file_name = str(filename).split('/')[-1].replace('.mp4', '.wav')

    clip.audio.write_audiofile(r"topics_find/audio_input/" + audio_file_name)

    return text_gen.convert_audio_to_text("topics_find/audio_input/" + audio_file_name)


def split_video_file(filename):
    return_list = []
    all_text = ''

    required_video_file = filename

    files = os.listdir('topics_find/video_input')

    for filename in files:
        os.remove('topics_find/video_input/' + filename)

    total_length = VideoFileClip(required_video_file).duration
    print(total_length)

    no_of_slices = int(total_length / 50) + 1

    time_grid = []

    for i in range(0, no_of_slices):
        time_grid.append(i * 50)

    for i in range(no_of_slices):
        if i == len(time_grid) - 1:
            # ffmpeg_extract_subclip(required_video_file, time_grid[i], total_length - time_grid[i],
            #                        targetname='videos/' + str(i) + ".mp4")
            pass
        else:
            ffmpeg_extract_subclip(required_video_file, time_grid[i], time_grid[i + 1],
                                   targetname='topics_find/video_input' + str(i) + ".mp4")
            text = convert_video_to_audio('topics_find/video_input' + str(i) + ".mp4")
            all_text += text + ' '
            return_list.append([i, text])

    return return_list, all_text
